if __name__ == "__main__":
    import sys
    sys.path.append("./site-packages")
import numpy as np
import pybaqus
import tqdm

def my_pybaqus_read_results(filename):
    #to avoid that numpy truncate the printed representation of its arrays
    np.set_printoptions(threshold=np.inf)
    model=pybaqus.open_fil(filename)
    nodes,kmap_nodes=model.get_node_coords(return_map=True)
    nodes_map_ids=np.empty(len(kmap_nodes),dtype=int)
    i=0
    for node_id in kmap_nodes.values():
        nodes_map_ids[i]=node_id
        i+=1
    element_connectivities,element_types,kmap_elements=model.get_cells(return_map=True)
    elements_map_ids=np.empty(len(kmap_elements),dtype=int)
    i=0
    for element_id in kmap_elements.values():
        elements_map_ids[i]=element_id
        i+=1
    nodal_result_all_steps = []
    for step in model.steps.keys():
        #num_incre_step=len(model.nodal_output[step].keys())
        #num_incre_step=len(model.steps[step].increments)
        #by now only results of last incre, and assuming its existence, GiD doesn't has this concept of incre to handle it properly, can do it with a name+incre...
        incre=model.steps[step].increments[-1]
        nodal_result_names=list(model.nodal_output[step][incre].keys())
        nodal_result_step = []
        for nodal_result_name in nodal_result_names :
            nodal_result_step.append(nodal_result_name)
            nodal_result_step.append(model.nodal_output[step][incre][nodal_result_name])
        nodal_result_all_steps.append(step)
        nodal_result_all_steps.append(nodal_result_step)
    elem_result_all_steps = []
    for step in model.steps.keys():
        #num_incre_step=len(model.elem_output[step].keys())
        #num_incre_step=len(model.steps[step].increments)
        #by now only results of last incre, and assuming its existence, GiD doesn't has this concept of incre to handle it properly, can do it with a name+incre...
        incre=model.steps[step].increments[-1]
        elem_result_names=list(model.elem_output[step][incre].keys())
        elem_result_step = []
        for elem_result_name in elem_result_names :
            elem_result_step.append(elem_result_name)
            elem_result_step.append(model.elem_output[step][incre][elem_result_name])
        elem_result_all_steps.append(step)
        elem_result_all_steps.append(elem_result_step)
    return [nodes,nodes_map_ids,element_connectivities,element_types,elements_map_ids,nodal_result_all_steps,elem_result_all_steps]


if __name__ == "__main__":
    #my_pybaqus_read_results("C:/gid project more/gidusers/Otros/Tadahiko Shiomi/Abaqus example/Job-2-E-mod.fil")
    #my_pybaqus_read_results("C:/gid project/plugins/Import/pybaqus/site-packages/examples/Displacement_visualization/model_results.fil")
    #my_pybaqus_read_results("C:/temp/test_abaqus/print_ascii.fil")
    my_pybaqus_read_results("C:/gid project more/gidusers/Otros/Tadahiko Shiomi/Abaqus_test_data/Abaqus_read_fil_test_data/AbaqusFilTestData_01.fil")