
if { [info command dict] eq "" } {
    package require dict
}
package require tdom
package require msgcat
package require snit
package require math::constants

if { 0 } {
    package require xml2pdf
    package require tooltip
}

namespace eval formulae {
    variable values ""
    variable values_default ""
    variable uvalues
    variable current_set
    variable unique_id 0
    variable images ""  
  
    variable active_user ""
    variable UMS_enabled 0  
}

proc formulae::unique_key {} {
    variable unique_id
    
    return "formulae::unique_key[incr unique_id]"
}

proc formulae::create_windowD { args } {
    variable values
    variable current_set
    variable uvalues   
    
    set optional {
	{ -tabstyle arrows|arrows_small|notebook|left_tree|right_tree|tree arrows }
	{ -update_callback callback "" }
	{ -destroy_callback callback "" }
	{ -delete_dom_on_destroy boolean 1 }
	{ -state normal|disabled normal }
	{ -lognoter_db db "" }
	{ -lognoter db "" }
	{ -database_default_table table "" }
	{ -maintain_grid boolean 1 }
	{ -showhidden boolean 0 }
	{ -default_title title_name "" }
	{ -notes_widgets widget "" }
	{ -bindings_list list "" }
	{ -page pageName "" }
    }
    set compulsory "wp key root"
    parse_args $optional $compulsory $args
    
    if { $root eq "" } {
	set xml {
	    <formulae usableviewmode="1" only_form_view_mode="0" tabstyle="">
	    <title></title>
	    <description/>
	    </formulae>
	}
	set new_doc [dom parse $xml]
	set new_root [$new_doc documentElement]
	dict set values $key page_tcl_code ""
    } else {
	set new_doc [dom createDocument [$root nodeName]]
	set new_root [$new_doc documentElement]
	foreach att [$root attributes] {
	    $new_root setAttribute $att [$root @$att]
	}
	set page_tcl_code ""
	foreach node [$root selectNodes //tcl] {
	    append page_tcl_code "[$node text]\n"
	}
	dict set values $key page_tcl_code $page_tcl_code

	foreach node [$root childNodes] {
	    $new_root appendChild $node
	}
    }
    if { [$new_root selectNodes {string(title)}] eq "" && $default_title ne "" } {
	set titleNode [$new_root selectNodes title]
	$titleNode appendChildText $default_title
    }
    if { [$new_root @tabstyle ""] ne "" } {
	set tabstyle [$new_root @tabstyle]
    }
    
    dict set values $key session_id [unique_key]

    set current_set(name,$key) ""
    array unset uvalues $key,*
    
    foreach "n v" [list doc $new_doc window_parent $wp update_stack ""  \
	    svg_stack "" uvalues_moredata "" nicer_name "" tabstyle $tabstyle \
	    update_callback $update_callback destroy_callback $destroy_callback \
	    delete_dom_on_destroy $delete_dom_on_destroy \
	    lognoter_db $lognoter_db lognoter $lognoter database_default_table \
	    $database_default_table state $state maintain_grid $maintain_grid \
	    showhidden $showhidden notes_widgets $notes_widgets \
	    bindings_list $bindings_list page $page] {
	dict set values $key $n $v
    }
    
    #package require tile
    package require wordwidget_snit
    package require tooltip
    namespace eval :: { namespace import -force tooltip::tooltip }

    create_images
    
    return [create_windowD_do $key]

#     if { $root eq "" } {
#         #set update_callback ""
#         form_properties -update_callback $update_callback $key $wp
#         set ret ""
#     } else {
#         set ret [create_windowD_do -maintain_grid $maintain_grid \
#                 -tabstyle $tabstyle]
#     }
#     return $ret
}

# create the formulae window
# args can be: ?-tabstyle arrows|arrows_small|notebook? ?-showhidden boolean?
proc formulae::create_windowD_do { args } {
    variable values
    variable values_default
    variable uvalues
    variable uvalues_initial
    variable current_set

    set optional {
	{ -tabstyle tabstyle - }
	{ -showhidden boolean - }
	{ -maintain_grid boolean 1 }
    }
    set compulsory "key"
    parse_args $optional $compulsory $args
    
    set doc [dict get $values $key doc]
    set root [$doc documentElement]
    set wp [dict get $values $key window_parent]

    set current_set(name,$key) ""
    array unset uvalues $key,*
    
    foreach n [list update_stack svg_stack uvalues_moredata nicer_name validate_cmd reload] {
	dict set values $key $n ""
    }
    foreach n [list use_scrollbarsH use_scrollbarsV] {
	dict set values $key $n [$root @$n 1]
    }
    if { [$root @tabstyle ""] ne "" } {
	dict set values $key tabstyle [$root @tabstyle]
    }
    dict set values $key print_formulas [$root @print_formulas yes]

    foreach i [list tabstyle showhidden maintain_grid] {
	if { [set $i] ne "-" } {
	    dict set values $key $i [set $i]
	}
    }
    
    dict set values $key reset_has_changes 0
    
    set active_tab 0
    if { [winfo exists $wp.n] } {
	catch { $wp.n index current } active_tab
	bind $wp.n <Destroy> ""
	if { [dict get $values $key maintain_grid] } {
	    set grid_info [grid info $wp.n]
	    if { $grid_info eq "" } {
		set grid_info [winfo manager $wp.n]
	    }
	}
	destroy $wp.n
    } else {
	set active_tab 0
    }

    dict set values $key usableviewmode [$root @usableviewmode 1]
    set updatebutton [$root @updatebutton ""]
    if { $updatebutton eq "" } {
	set xp {//param[@field_type="expression" or 
	    @field_type="text expression" or
	    @field_type="formatted expression" or
	    starts-with(@value,'[')]}
	if { [$root selectNodes $xp] ne "" } {
	    set updatebutton 1
	} else {
	    set updatebutton 0 
	}
    }

    if { [dict get $values $key usableviewmode] } {
	set db_state normal
    } else {
	set db_state [dict get $values $key state]
    }
    
    set lognoter [dict get $values $key lognoter]
    set lognoter_db [dict get $values $key lognoter_db]
    
    if { [$root @user_defined_frame ""] ne "" && [dict get $values $key state] eq "disabled" } {
	set table [$root @database ""]
	set page [dict get $values $key page]
	set err [catch { uplevel #0 [$root @user_defined_frame] [list $wp init $lognoter \
	     $lognoter_db $table $page] } ret]
	if { $err } {
	    if { [set! ::lognoter_debug] } {
		set ret $::errorInfo
	    }
	    snit_messageBox -message $ret
	} else {
	    return $ret
	}
    }
    
    if {  [$root @database ""] ne "" } {
	if { ![$lognoter_db sql table_exists [$root @database]] } {
	    error [_ "Error: table '%s' does not exist" [$root @database]]
	}
    }
    set create_edit_delete_cmds ""
    foreach i [list create edit edit_multiple delete] {
	if { [$root @${i}_command ""] ne "" } {
	    dict set create_edit_delete_cmds $i [$root @${i}_command ""]
	}
    }
    snit_notebook $wp.n -type_name [dict get $values $key tabstyle] \
	-lognoter_db [dict get $values $key lognoter_db] \
	-database [$root @database ""] -rootnode $root \
	-dbstate $db_state -main_state [dict get $values $key state] \
	-actualize_callback [namespace code [list window_actualize -raise_error \
		-exec_callback 0 $key]] \
	-preferred_tree_position [dict_getd $values_default $key preferred_tree_position left] \
	-fill_form_callback [namespace code [list fill_form $key]] \
	-eval_command [namespace code [list eval_in_interp $key]] \
	-contextual_add_callback [namespace code [list add_to_contextual $key]] \
	-notes_widgets [dict_getd $values $key notes_widgets ""] \
	-create_edit_delete_cmds $create_edit_delete_cmds
    
    dict set values $key notebook_widget $wp.n

    if { [info exists grid_info] } {
	if { [string match paned* $grid_info] } {
	    set p [lindex [grid slaves $wp] 0]
	    $p insert 0 $wp.n -weight 1
	} elseif { $grid_info ne "" } {
	    grid $wp.n {*}$grid_info
	}
    }
    set lognoter [dict_getd $values $key lognoter ""]
    if { $lognoter ne "" } {
	set page [[dict get $values $key lognoter] cget -page]
    } else {
	set page ""
    }
    set interp [_create_interp $key $lognoter $lognoter_db $wp.n [$root @database ""] $page]
    dict set values $key interp $interp
    dict set values $key bindtag $interp
    
    check_connect_ramdebugger $key
    
    if { [dict get $values $key page_tcl_code] ne "" } {
	$interp eval source [list [file join $::topdir tcl webapp_support.tcl]]
	set err [catch {$interp eval [list set ::base_path '']}]
	set err [catch { $interp eval [dict get $values $key page_tcl_code] } errstring]
	if { $err } {
	    snit_messageBox -message $errstring
	} 
    }

    foreach bind_key [bind $interp] {
	bind $interp $bind_key ""
    }
    foreach i [dict get $values $key bindings_list] {
	lassign $i bind_key cmd
	bind $interp $bind_key $cmd
    }
    bind $wp.n <Destroy> [namespace code [list destroy_window $key]]
    bind [winfo toplevel $wp] <Control-h> [namespace code [list create_windowD_do \
		-showhidden [expr {([dict get $values $key showhidden])?0:1}] $key]]

    #if { $root eq "" } { return $wp.n }
    
    incr idx
    set ff [frame $wp.n.f$idx -bd 0]
    set c [canvas $ff.c -bd 0 -yscrollcommand [list $ff.sb set] \
	    -xscrollcommand [list $ff.sh set]]    
    bind $c <4> { %W yview scroll -50 pixels }
    bind $c <5> { %W yview scroll 50 pixels }

    scrollbar $ff.sb -orient vertical -command [list $ff.c yview]
    scrollbar $ff.sh -orient horizontal -command [list $ff.c xview]
    grid $c $ff.sb -sticky ns
    grid $ff.sh -sticky ew
    grid configure $c -sticky nsew
    grid remove $ff.sb
    grid remove $ff.sh
    grid columnconfigure $ff 0 -weight 1
    grid rowconfigure $ff 0 -weight 1
    
    set f [frame $ff.f]
    $c create window 0 0 -anchor nw -window $f
    bind $c <Configure> [list formulae::adjust_canvas_frame $key $c $f $ff.sb $ff.sh]
    bind $f <Configure> [list formulae::adjust_canvas_frame $key $c $f $ff.sb $ff.sh]
    grid columnconfigure $f 0 -weight 1
    $wp.n add $ff -sticky nsew -text [_ "Intro"] -image [cu::get_icon iconthemes-16] \
	-compound left
    
    lassign [list 0 0] idxw numlf

    bind $f <ButtonRelease-3> [namespace code [list header_contextual_menu $key $wp \
		%X %Y]]
    
    dict set values $key creating_window 1
    
    set numContainers 0
    foreach node [$root selectNodes title|description|container|setname] {
	switch [$node nodeName] {
	    title {
		set l [cu::nicelabel $f.l[incr idxw]]
		set txt [$node text]
		if { [string index $txt 0] == "\[" } {
		    set cmd1 [string range $txt 1 end-1]
		    set cmd [namespace code [list update_title_description $key $l $cmd1]]
		    set update_stack [dict get $values $key update_stack]
		    lappend update_stack $cmd
		    dict set values $key update_stack $update_stack
		}
		$l insert end $txt bold
		ttk::frame $f.lbuts
		set gridList ""
		if { $updatebutton } {
		    set cmd [namespace code [list window_actualize \
		                -conditions_window %W $key]]
		    set tooltip [_ "Actualize formulae values (Return)"]
		    if { [dict get $values $key state] eq "disabled" && 
		        ![dict get $values $key usableviewmode] } {
		        set state disabled
		    } else {
		        set state normal
		    }
		    if { ![$wp.n try_add_actualize_button [cu::get_icon iconthemes-16] \
		        [_ "Actualize"] $cmd $state $tooltip] } {
		        destroy $wp.actualize_butt
		        set cmd [string map [list %W $f.lbuts.actualize_butt] $cmd]
		        set b [ttk::button $f.lbuts.actualize_butt -image [cu::get_icon iconthemes-16] \
		                -text [_ "Actualize"] -compound left -command $cmd -state $state]               
		        lappend gridList $b
		        tooltip $b $tooltip
		    }
		}
		if { [$root @help_html ""] ne "" || [$root @help_lognoter ""] ne "" } {
		    if { [$root @help_lognoter ""] ne "" } {
		        set cmd [list formulae::_open_lognoter_help $key $wp [$root @help_lognoter]]
		    } else {
		        set cmd [list formulae::_open_html_help $key $wp [$root @help_html]]
		    }
		    destroy $wp.help_butt
		    set hh [ttk::button $f.lbuts.help_butt -image [cu::get_icon help-16] \
		            -style Toolbutton -command $cmd]
		    lappend gridList $hh
		}
		if { [$root selectNodes import_pages] ne "" } {
		    set ip [cu::menubutton_button $f.lbuts.import_pages \
		            -image [cu::get_icon dialog-information-16] \
		            -style Toolbutton -command [list formulae::import_other_forms $key $wp] \
		            -menu $f.lbuts.import_pages.m]
		    set m [menu $f.lbuts.import_pages.m -tearoff 0]
		    foreach n [$root selectNodes import_pages] {
		        $m add command -label [lindex [split [$n text] >] end] -command \
		            [list formulae::import_other_forms -page [$n text] $key $wp]
		    }
		    $m add separator
		    $m add command -label [_ "Import"]... -command \
		        [list formulae::import_other_forms $key $wp]
		    tooltip $ip [_ "Import data from other forms"]
		    lappend gridList $ip
		}
		if { [llength $gridList] } {
		    grid {*}$gridList -sticky w
		}
		grid $l $f.lbuts -in $f -sticky w
		grid configure $l -sticky we -padx 2
		grid columnconfigure $f 0 -weight 1

		bind $l <ButtonRelease-3> [namespace code [list header_contextual_menu $key $wp \
		            %X %Y]]
		
	    }
	    description {
		set txt [string trim [$node text]]
		if { $txt ne "" } {
		    set l [cu::nicelabel $f.l[incr idxw]]
		}
		if { [string index $txt 0] == "\[" } {
		    set cmd1 [string range $txt 1 end-1]
		    set cmd [namespace code [list update_title_description $key $l $cmd1]]
		    set update_stack [dict get $values $key update_stack]
		    lappend update_stack $cmd
		    dict set values $key update_stack $update_stack
		}
		if { $txt ne "" } {
		    $l insert end $txt
		    grid $l -sticky nwe -columnspan 2 -pady 2 -padx 2
		    bind $l <ButtonRelease-3> [namespace code [list header_contextual_menu \
		                $key $wp %X %Y]]

		}
	    }
	    setname {
		# this is obsolete
		set valuesList ""
		foreach "numprinted numtotal" [list 0 0] break
		foreach cnode [$node selectNodes name] {
		    lappend valuesList [$cnode @n]
		    incr numprinted [$cnode @print 1]
		    incr numtotal
		}
		set current_set(name,$key) [$node @n ""]
		set current_set(print,$key) [$node @print 1]
		if { $numprinted == $numtotal } {
		    set current_set(print_all_none,$key) all
		} elseif { $numprinted > 0 } {
		    set current_set(print_all_none,$key) some
		} else {
		    set current_set(print_all_none,$key) none
		}

		set f1 [frame $f.f[incr idxw]]
		set l [ttk::label $f1.l[incr idxw] -text [_ "Set name:"]]
		set cb [ttk::combobox $f1.cb[incr idxw] -textvariable \
		        [namespace current]::current_set(name,$key) -values $valuesList]
		if { [dict get $values $key state] eq "disabled" } {
		    if { [dict get $values $key usableviewmode] } {
		        $cb state readonly
		    } else {
		        $cb state disabled
		    }
		}
		
		tooltip $l [_ "A set name is a way to store a group of values and results for later tabular printing"]
		
		#focus $cb
		bindtags $cb [concat $interp [bindtags $cb]]
		bind $cb <<ComboboxSelected>> [namespace code [list manage_names select \
		            $key $f1.cb$idxw $node]]
		bind $cb <Return> [namespace code [list manage_names accept $key $cb $node]]
		set mb [cu::menubutton_button $f1.mb[incr idxw] -image [cu::get_icon bookmark_add-16] \
		        -menu $f1.mb$idxw.m -state [dict get $values $key state] -command \
		        [namespace code [list manage_names accept $key $cb $node]]]
		menu $f1.mb$idxw.m -tearoff 0
		$f1.mb$idxw.m add command -label [_ "Create new set"] -command \
		    [namespace code [list manage_names accept $key $cb $node]] \
		    -acc "Return"
		$f1.mb$idxw.m add separator
		$f1.mb$idxw.m add checkbutton -label [_ "Print"] -variable \
		    [namespace current]::current_set(print,$key) -command \
		    [namespace code [list manage_names print $key $cb $node]]
		$f1.mb$idxw.m add separator
		$f1.mb$idxw.m add radiobutton -label [_ "Print all"] -command \
		    [namespace code [list manage_names printall $key $cb $node]] -variable \
		    [namespace current]::current_set(print_all_none,$key) -value all
		$f1.mb$idxw.m add radiobutton -label [_ "Print none"] -command \
		    [namespace code [list manage_names printnone $key $cb $node]] -variable \
		    [namespace current]::current_set(print_all_none,$key) -value none
		$f1.mb$idxw.m add separator
		$f1.mb$idxw.m add command -label [_ "Delete"] -command \
		    [namespace code [list manage_names delete $key $cb $node]]
	    
		grid $l $cb $mb -sticky we
		grid columnconfigure $f 1 -weight 1
		grid $f1 -sticky nw -columnspan 2 -pady 2 -padx 2
	     
		if { [dict get $values $key state] eq "normal" } {
		    foreach i [list $l $cb $mb] {
		        bind $i <ButtonRelease-3> [namespace code [list header_contextual_menu \
		                    $key $wp %X %Y]]
		    }
		} else {
		    foreach i [list $l $cb $mb] {
		        tooltip $i [_ "Sets can only be modified in edit page mode"]
		    }
		}  
	    }
	    container {
		if { [$node @location ""] ne "same_page" } {
		    if { $numlf != 0 } { incr idx }
		    set txt ""
		    foreach i [list pns pn n] {
		        if { [$node @$i ""] ne "" } {
		            set txt [$node @$i]
		            break
		        }
		    }
		    if { $txt eq "" } {
		        set txt [_ "Step %d" $idx]
		    }
		    if { $numlf != 0 } {
		        set ff [frame $wp.n.f$idx -bd 0]
		        set c [canvas $ff.c -bd 0 -yscrollcommand [list $ff.sb set] \
		                -xscrollcommand [list $ff.sh set]]
		        
		        bind $c <4> { %W yview scroll -50 pixels }
		        bind $c <5> { %W yview scroll 50 pixels }

		        scrollbar $ff.sb -orient vertical -command [list $ff.c yview]
		        scrollbar $ff.sh -orient horizontal -command [list $ff.c xview]
		        grid $c $ff.sb -sticky ns
		        grid $ff.sh -sticky ew
		        grid $c -sticky nsew
		        grid remove $ff.sb
		        grid remove $ff.sh
		        grid columnconfigure $ff 0 -weight 1
		        grid rowconfigure $ff 0 -weight 1
		        
		        set f [frame $ff.f]
		        $c create window 0 0 -anchor nw -window $f
		        bind $c <Configure> [list formulae::adjust_canvas_frame $key $c $f $ff.sb $ff.sh]
		        bind $f <Configure> [list formulae::adjust_canvas_frame $key $c $f $ff.sb $ff.sh]
		        grid columnconfigure $f 0 -weight 1
		        grid rowconfigure $f 1 -weight 1
		        $wp.n add $ff -sticky nsew -text $txt -image \
		            [cu::get_icon contents2-16] -compound left
		        foreach "idxw numlf" [list 1 0 0] break                       
		    } else {
		        $wp.n tab 0 -text $txt -image [cu::get_icon contents2-16]
		    }
		}
		set cstate [$node @state normal]
		if { $cstate eq "hidden" && [dict get $values $key showhidden] } {
		    set cstate normal
		}
		if { $cstate eq "hidden" } {
		    $wp.n tab $f -state hidden
		} elseif { [$node @condition ""] ne "" } {                    
		    set cmd [namespace code [list check_container_condition \
		                [$node @n ""] [$node @condition ""] $wp.n $ff $key]]
		    set update_stack [dict get $values $key update_stack]
		    lappend update_stack $cmd
		    dict set values $key update_stack $update_stack
		}
		if { [$node @help ""] ne "" || [$node @help_html ""] ne "" || [$node @help_lognoter ""] ne "" } {
		    set l [cu::nicelabel $f.l[incr idxw]]
		    $l insert end [string trim [$node @help]]
		    set fb [frame $f.fb[incr idxw]]
		    set b [ttk::button $fb.b1 -image \
		            [cu::get_icon iconthemes-16] \
		            -command [namespace code [list window_actualize $key]]]
		    
		    if { [$node @help_html ""] ne "" || [$node @help_lognoter ""] ne "" } {
		        if { [$node @help_lognoter ""] ne "" } {
		            set cmd [list formulae::_open_lognoter_help $key $wp [$node @help_lognoter]]
		        } else {
		            set cmd [list formulae::_open_html_help $key $wp [$node @help_html]]
		        }
		        ttk::button $fb.b2 -image [cu::get_icon help-16] \
		            -style Toolbutton -command $cmd
		        grid $fb.b1 $fb.b2 -sticky w
		    } else {
		        grid $fb.b1 -sticky w
		    }
		    grid $l $fb -sticky nw -padx 2 -pady 2
		    grid configure $l -sticky nwe
		    grid columnconfigure $f 0 -weight 1
		    tooltip $b [_ "Update values (Return)"]
		    bind $l <ButtonRelease-3> [namespace code [list entry_contextual_menu \
		                $key $wp [$node @n] container %X %Y]]
		}
		set l [ttk::labelframe $f.l[incr idxw] -text [node_pn $node] \
		        -padding "0 0 0 2"]
		grid $l -sticky nsew -columnspan 2 -padx 5 -pady "2 5"
#                 set nrows [lindex [grid size $f] 1]
#                 foreach i [range 0 $nrows] { grid rowconfigure $f $i -weight 0 }
#                 grid rowconfigure $f $nrows -weight 1

		set ns { svg http://www.w3.org/2000/svg }
		set svgNode [$node selectNodes -namespaces $ns svg:svg]
		if { $svgNode ne "" } {
		    package require xml2pdf
		    ttk::panedwindow $l.p -orient horizontal
		    $l.p add [frame $l.p.f1]
		    canvas $l.p.c -background white
		    set svg2draw [svg2draw %AUTO% -destroy_with_canvas 1 -canvas $l.p.c]
		    set svg_stack [dict get $values $key svg_stack]
		    lappend svg_stack $svg2draw
		    dict set values $key svg_stack $svg_stack
		    if { [dict get $values $key state] eq "normal" } {
		        $svg2draw configure -add_to_contextual \
		            [namespace code [list add_drawing_contextual_menu $key \
		                    [$node @n] $l.p.c]]
		    }
		    catch { $svg2draw draw -svgNode $svgNode }
		    $l.p add $l.p.c
		    grid $l.p -sticky nwes
		    grid columnconfigure $l 0 -weight 1
		    grid rowconfigure $l 0 -weight 1
		    set l $l.p.f1
		}
		if { [$node @window_create_func ""] ne "" } {
		    set cmd [$node @window_create_func]
		    lappend cmd $key $l $node formulae::uvalues
		    uplevel #0 $cmd
		} else {
		    process_window_container $key $l $node $idx
		}
		bind $l <ButtonRelease-3> [namespace code [list entry_contextual_menu \
		            $key $wp [$node @n] container %X %Y]]

		if { ![llength [winfo children $l]] } {
		    $l configure -height 50
		}
		set weight_row 0
		set nrows [lindex [grid size $l] 1]
		for { set i 0 } { $i < $nrows } { incr i } {
		    if { [grid rowconfigure $l $i -weight] > 0 } {
		        set weight_row 1
		        break
		    }
		}
		if { $weight_row } {
		    grid rowconfigure $f $l -weight 1
		    if { [dict get [grid info $l] -row] == 0 } {
		        grid rowconfigure $f 1 -weight 0
		    }
		}
		bind $l <ButtonRelease-3> [namespace code [list entry_contextual_menu \
		            $key $wp [$node @n] container %X %Y]]
		incr numlf
		incr numContainers
	    }
	}
    }
    if { !$numContainers && [dict get $values $key state] ne "disabled" } {
	cu::nicelabel $f.lwarning -width 500
	set t [_ "Use contextual menu (right button mouse) over the field elements in order to modify this form"]
	$f.lwarning insert end $t "bold red"
	
	grid $f.lwarning - -sticky ew -padx 2 -pady 40
	grid columnconfigure $f 0 -weight 1
	
	bind $f.lwarning <ButtonRelease-3> [namespace code [list header_contextual_menu $key $wp \
		    %X %Y]]
    }
    dict unset values $key creating_window
    window_actualize $key
    catch { $wp.n select $active_tab }
    $wp.n _compute_size

    cu::set_focus_recursive $f
    
    #after idle [namespace code [list _check_paned_size $wp.n]]
    
    foreach "n v" [array get uvalues "$key,*"] {
	set uvalues_initial($n) $v
    }
    dict set values $key uvalues_moredata_initial [dict get $values $key uvalues_moredata]

    if { [dict get $values $key state] eq "disabled" } {    
	$wp.n manage_database fill_entries_default
    }
    return $wp.n
}