# Tcl package index file, version 1.1
# This file is generated by the "pkg_mkIndex" command
# and sourced either when an application starts up or
# by a "package unknown" script.  It invokes the
# "package ifneeded" command to set up package-related
# information so that packages will be loaded automatically
# in response to "package require" commands.  When this
# script is sourced, the variable $dir must contain the
# full path name of this file's directory.
proc source_customlib_extras { dir } {
    set ::CUSTOM_LIB_WINDOW_VALUES_SCROLLED 1 ;#to allow vertical scrollbar in customLib window values
    foreach filename {customlib_extras.tcl} {
        source [file join $dir $filename]
    }
}

proc source_customlib_native_groups { dir } {
    #now it is not necessary to source any extra file redefining some procedures of customLib gid_groups_conds.tcl, modified procedures are changed directly in customLib
    package require customLib
    set ::CUSTOM_LIB_USE_NATIVE_GROUPS 1
    set ::CUSTOM_LIB_USE_NATIVE_GROUPS_DRAW_NATIVE 1 ;#0 to use old procedure tcl that create gl draw list
    if { ![info exists ::GidPriv(ShowGroupsTab)] || $::GidPriv(ShowGroupsTab)==0 } {
        set ::GidPriv(ShowGroupsTab) 1 ;#0 to hide the native groups tab
    }    
    package provide customlib_native_groups 0.3
}

proc source_customlib_groups_window_use_native_groups { dir } {
    #now it is not necessary to source any extra file redefining some procedures of customLib groups.tcl, modified procedures are changed directly in customLib
    package require customlib_native_groups
    if { $::GidPriv(ShowGroupsTab) } {
        set ::GidPriv(ShowGroupsTab) 0 ;# 0 to hide the standard groups tab (if this package is required is to use the old window tunned)
    }
    package provide customlib_groups_window_use_native_groups 0.3
}
package ifneeded customlib_extras 0.4 [list source_customlib_extras $dir] ;#extra procedures, with native or conditions groups
package ifneeded customlib_native_groups 0.3 [list source_customlib_native_groups $dir] ;#to adapt the tree to internally use native groups instead of conditions
package ifneeded customlib_groups_window_use_native_groups 0.3 [list source_customlib_groups_window_use_native_groups $dir] ;#to adapt the 'condition-groups window' to internally use native groups instead of conditions