
#
proc test_gid_json { { do_indent 1}} {
    set fail 0
    set debug 0

    package require gid_json

    set t "ja ja ja" ;
    # need to to [ expr Integer] to get 'int' representation
    # otherwise it will be handles as string
    set a_list [ list [ expr 123] "555" [ expr 43.65] "some other coordinates" [ dict create in inside out outside]]
    set my_dd [ dict create \
        hola mundo \
        adios $t \
        $t "mundo\n$t" \
        a_list $a_list \
        a_list_length [ llength $a_list] \
        otro_dict [ dict create \
            nido uno \
            pajaro pajarito \
            str-utf-8 "X-位 (japanese), Y-안전 구역 (korean), Z-移位 (chinese), ¡Ñandú!" \
            valor 0 \
            "3 dict" [ dict create aaaa [ expr 1111] bbbb [ expr 2222] things $a_list] \
        ] \
        enabled false \
        "null value" null \
        "undefined value" undefined \
    ]
    set my_dd_json [ gid_json::dict2json $my_dd $do_indent]

    package require rl_json
    set is_json_valid [ rl_json::json valid $my_dd_json]
    if { $debug} {
        W "json is valid: $is_json_valid"
        WV "my_dd my_dd_json"
        W [ gid_json::json2dict $my_dd_json]
        W ----
    }
    if { !$is_json_valid} {
        incr fail
    }
    return $fail

    # test if created json can be read by tcllib/json pacakge
    # and correctly formated back
    package require json
    # this will not work with '\n'
    set json_dict [ ::json::json2dict $my_dd_json]
    set json_dict_test [ gid_json::dict2json $json_dict $do_indent]

    if { [ string equal $my_dd_json $json_dict_test]} {
        if { $debug} {
            W "json strings are identical"
        }
    } else {
        if { $debug} {
            W "json strings differ"
            WV "my_dd_json json_dict_test"
        }
        incr fail
    }
    if { [ string equal $my_dd $json_dict]} {
        if { $debug} {
            W "source dicts are identical"
        }
    } else {
        if { $debug} {
            W "source dicts differ"
            WV "my_dd json_dict"
        }
        incr fail
    }

    # can be validated with https://jsonlint.com/
    return $fail
}
