#test to usurpate in GiD the gid_togl with other widget (e.g. to use a local GUI working remotely with a gid_offscreeen providing the image)
#package require gid_pseudo_togl
#rename gid_togl gid_togl_true ; rename gid_pseudo_togl gid_togl

package require Tk
package require snit

snit::widgetadaptor gid_pseudo_togl {
    
    delegate option * to hull
    delegate method * to hull
    
    option -rgba -default true
    option -double -default true
    option -depth -default true
    option -ident -default GID
    option -privatecmap -default false
    option -redsize -default 8
    option -greensize -default 8
    option -bluesize -default 8
    option -alphasize -default 8
    option -alpha -default true
    option -depthsize -default 32
    option -stencil -default true
    option -stencilsize -default 8
    option -sharelist -default ""
    option -softrender -default false
    
    constructor {args} {
        installhull using canvas
        #installhull using label
        $self configurelist $args
        return
    }

    proc print_message { txt } {
        W "PSEUDO TOGL: $txt"
    }

    #   method configure { args } {
    #      print_message "configure $args"
    #   }

    method render { args } {
        GiD_Redraw
    }
    method swapbuffers { args } {
        print_message "swapbuffers $args"
    }
    method makecurrent { args } {
        print_message "makecurrent $args"
    }
    method loadbitmapfont { args } {
        print_message "loadbitmapfont $args"
    }
    method unloadbitmapfont { args } {
        print_message "unloadbitmapfont $args"
    }
    method process { args } {
        print_message "DEPRECATED process $args"
    }
    method processlist { args } {
        print_message "DEPRECATED processlist $args"
    }
    #method info { args } {
    #  print_message "DEPRECATED info $args"
    #}
    method motion { args } {
        gid_server_eval_async [list $self motion {*}$args]
    }
    method graphmode { args } {
        print_message "DEPRECATED graphmode $args"
    }
    method draw_dynamic_box { x y mode } {
        variable rectangle_id
        variable x0
        variable y0
        if { $mode == "BEGIN" } {
            set x0 $x
            set y0 $y           
            #set rectangle_id [$self create rectangle $x0 $y0 $x $y -width 1 -fill cyan -stipple gray12]
            set rectangle_id [$self create rectangle $x0 $y0 $x $y]
        } elseif { $mode == "CONTINUE" } {
            if { [info exists rectangle_id] } {        
                #lassign [lrange [$self coords $rectangle_id] 0 1] x0 y0
                if { $x >= $x0 } {
                    set x_max $x
                    set x_min $x0
                } else {
                    set x_max $x0
                    set x_min $x
                }
                if { $y >= $y0 } {
                    set y_max $y
                    set y_min $y0
                } else {
                    set y_max $y0
                    set y_min $y
                }        
                $self coords $rectangle_id $x_min $y_max $x_max $y_min
            }
        } elseif { $mode == "END" } {
            if { [info exists rectangle_id] } {
                $self delete $rectangle_id 
                unset rectangle_id
            }
        } else {
        }
    }
    method draw_dynamic_line { x y mode } {
        variable line_id
        if { $mode == "BEGIN" } {           
            set rectangle_id [$self create line $x $y $x $y -width 2]
        } elseif { $mode == "CONTINUE" } {
            if { [info exists line_id] } {        
                $self coords $line_id {*}[lrange [$self coords $line_id] 0 1] $x $y
            }
        } elseif { $mode == "END" } {
            if { [info exists line_id] } {
                $self delete $line_id 
                unset line_id
            }
        } else {
        }
    }
    method leave { args } {
        gid_server_eval_async [list $self leave {*}$args]
    }
    method enter { args } {
        gid_server_eval_async [list $self enter {*}$args]
    }
    method button { args } {
        gid_server_eval_async [list $self button {*}$args]
    }
    method flushBatchToWrite { args } {
        print_message "DEPRECATED flushBatchToWrite $args"
    }
    method disable { args } {
        print_message "DEPRECATED disable $args"
        return 0        
    }
    method waitstate { args } {
        print_message "DEPRECATED waitstate $args"
    }
    method makenewwindow { args } {
        #print_message "makenewwindow $args"
    }
    method recordbatch { args } {
        print_message "DEPRECATED recordbatch $args"
    }
    method OutPutPrintedMessages { args } {
        print_message "OutPutPrintedMessages $args"
    }
    method gidmakecurrent { args } {
        #print_message "gidmakecurrent $args"
    }
    method SetPosition { args } {
        print_message "SetPosition $args"
    }
    method clearprojectchanges { args } {
        print_message "DEPRECATED clearprojectchanges $args"
    }
    method wordcomeraseall { args } {
        print_message "wordcomeraseall $args"
    }
}

proc gid_pseudo_togl_redefine_commands { } {
    rename gid_togl togl_Original 
    rename gid_pseudo_togl gid_togl   
}


