proc LoadLibraryTdbcPostgres { dir basename } {
    package require Tcl 8.6   
    if { $::tcl_platform(pointerSize) == 8} {
	    set bits 64
    } else {
	    set bits 32
    }
    if { $::tcl_platform(platform) == "windows" } {
	    set library ${basename}115t_${bits}[info sharedlibextension]
        #GiD: add to path the folder with the extra dll libraries of postgresql
        #binaried obtained from https://www.enterprisedb.com/download-postgresql-binaries
        set ::env(path) "$::env(path);[file nativename [file join $dir pgsql x${bits}]]"
    } else {
	    set library lib${basename}1.1.5[info sharedlibextension]	 
    }
    source [file join $dir tdbcpostgres.tcl]
    load [file join $dir $library] $basename  
}

package ifneeded tdbc::postgres 1.1.5 [list LoadLibraryTdbcPostgres $dir tdbcpostgres]
