proc load_library_tdom  { dir basename } {
    if { $::tcl_platform(pointerSize) == 8 } {
        set bits 64
    } else {
        set bits 32
    }
    if { $::tcl_platform(platform) eq "windows"} {
        set library ${basename}_${bits}[info sharedlibextension]
        load [file join $dir $library] $basename
        if { $bits == "64" } {
            source [file join $dir tdom.tcl]
        } else {
            source [file join $dir tdom-0.9.3.tcl]
        }
    } else {
        #set library lib${basename}_${bits}[info sharedlibextension]
        set library lib${basename}0.9.5[info sharedlibextension]
        load [file join $dir $library] $basename
        source [file join $dir tdom.tcl]
    }
}

if { $::tcl_platform(platform) eq "windows"} {
    if { $::tcl_platform(pointerSize) == 8 } {
        # set bits 64
        package ifneeded tdom 0.9.5 [list load_library_tdom $dir tdom]
    } else {
        package ifneeded tdom 0.9.3 [list load_library_tdom $dir tdom]
    }
} else {
    package ifneeded tdom 0.9.5 [list load_library_tdom $dir tdom]
}
