proc load_library_tktable  { dir basename version } {
    if { $::tcl_platform(os) == "Darwin"} {
	# set library lib${basename}${version}[info sharedlibextension]
	set library lib${basename}_64[info sharedlibextension]
    } else {
	if { $::tcl_platform(pointerSize) == 8} {
	    set bits 64
	} else {
	    set bits 32
	}
	set library ${basename}_${bits}[info sharedlibextension]
        if { $::tcl_platform(os) == "Linux"} {
            set library lib$library
        }
    }
    load [file join $dir $library] $basename
}

if {[catch {package require Tcl 8.2}]} return

package ifneeded Tktable 2.10 [list load_library_tktable $dir Tktable 2.10]
