
proc test_verifp { } {
    set fail 0
    set debug 0

    package require verifp
    set data_vp [lindex [vp_getsysinfo] 0]
    set data_gid ""
    if { $::tcl_platform(platform) == "windows" } {
        set exe [file join $::GIDDEFAULT gid.exe]
        if { ![file exists $exe] } {
            if { $::tcl_platform(pointerSize) == 8 } {
                set bits 64
            } else {
                set bits 32
            }
            set exe [file join $::GIDDEFAULT gid_$bits.exe]
        }
    } else {
        set exe [file join $::GIDDEFAULT gid]
        if { ![file exists $exe] || ![file isfile $exe] } {
            set exe [file join $::GIDDEFAULT run_gid.sh]
        }
    }
    catch { exec $exe -outputinfo local } data_gid
    # if { $exe == [file join $::GIDDEFAULT run_gid.sh] } {
    #    #run_gid.sh prints an extra line like "Launching /home/gid/GID-git/gidproject/gid/gid_release.exe -outputinfo local"
    #    set data_gid [lindex [split $data_gid \n] 1]
    #}
    #check coincidence of identifiers of verifp and gid.exe
    if { $data_vp != $data_gid } {
        # incr fail
        # encode test number in fail
        set fail [ expr $fail + 1]
        if { $debug} {
            W "check coincidence of identifiers of verifp and gid.exe ="
            WV [ list data_vp data_gid] "    "
        }
    }
    set hostname [ info hostname]
    if { $hostname == "desktop-8f99sb0" && $data_vp != "desktop-8f99sb0 windows 80b0040300000037"} {
        # incr fail
        # encode test number in fail
        set fail [ expr $fail + 20]
        if { $debug} {
            W "wanted hostname = desktop-8f99sb0  and  data_vp = desktop-8f99sb0 windows 80b0040300000037"
            W "but got ="
            WV [ list hostname data_vp] "    "
        }
    }
    if { $hostname == "eon" && $data_vp != "eon windows d7a2772bf690d19e"} {
        # incr fail
        # encode test number in fail
        set fail [ expr $fail + 300]
        if { $debug} {
            W "wanted hostname = eon  and  data_vp = eon windows d7a2772bf690d19e"
            W "but got ="
            WV [ list hostname data_vp] "    "
        }
    }
    # hoschi sysinfo changed
    # before:            hoschi linux 00008f0018eefc85
    # now (2023-02-14) : hoschi linux 00008f00173bfc5f
    set hoschi_info "hoschi linux 00008f00173bfc5f"
    if { $hostname == "hoschi" && $data_vp != $hoschi_info} {
        # incr fail
        # encode test number in fail
        set fail [ expr $fail + 4000]
        if { $debug} {
            W "wanted hostname = hoschi  and  data_vp = $hoschi_info"
            W "but got ="
            WV [ list hostname data_vp] "    "
        }
    }
    return $fail
}
