*#FILE_EXTENSION .msh
*realformat "%15.9g"
*intformat "%8i"
*# Interface GID-gmsh to export mesh in gmsh format
*# https://gmsh.info/doc/texinfo/gmsh.html#MSH-file-format-version-2-_0028Legacy_0029
*# Written by Kike III - July 2021
$MeshFormat
2.2 0 8
$EndMeshFormat
$PhysicalNames
0
*# physical-dimension physical-tag "physical-name"
$EndPhysicalNames
$Nodes
*npoin
*loop nodes
*nodesnum *nodescoord(1) *nodescoord(2) *nodescoord(3)
*end nodes
$EndNodes
$Elements
*nelem
*# elm-number elm-type number-of-tags < tag > … node-number-list
*set var gmshelemtype(int)=0
*loop elems
*if(ElemsType==1)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=1
*else
*set var gmshelemtype=8
*endif
*elseif(ElemsType==2)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=2
*else
*set var gmshelemtype=9
*endif
*elseif(ElemsType==3)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=3
*elseif(IsQuadratic(int)==1)
*# 8-node quadrilateral
*set var gmshelemtype=16
*else
*# 9-node quadrilateral
*set var gmshelemtype=10
*endif
*elseif(ElemsType==4)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=4
*else
*set var gmshelemtype=11
*end if
*elseif(ElemsType==5)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=5
*elseif(IsQuadratic(int)==1)
*# 20-node hexahedron
*set var gmshelemtype=17
*else
*# 27-node hexahedron
*set var gmshelemtype=12
*end if
*elseif(ElemsType==6)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=6
*elseif(IsQuadratic(int)==1)
*# 15-node prism
*set var gmshelemtype=18
*else
*# 18-node prism
*set var gmshelemtype=13
*end if
*elseif(ElemsType==7)
*# 1-node point
*set var gmshelemtype=15
*elseif(ElemsType==8)
*if(IsQuadratic(int)==0)
*set var gmshelemtype=7
*elseif(IsQuadratic(int)==1)
*# 15-node pyramid
*set var gmshelemtype=14
*else
# 13-node pyramid
*set var gmshelemtype=19
*end if
*elseif(ElemsType==9)
*#sphere, write like point
*set var gmshelemtype=7
*elseif(ElemsType==10)
*#circle, write like point
*set var gmshelemtype=7
*else
*# unexpected
*set var gmshelemtype=0
*end if
*# I am writting 2 element tags: the material id and the layer id but could write 0 tags
*elemsnum *gmshelemtype(int) 2 *elemsmat *elemslayernum *elemsconec
*end elems
$EndElements
$Periodic
0
*# dimension entity-tag master-entity-tag
*# number-of-nodes
*# node-number master-node-number
$EndPeriodic
$NodeData
*# number-of-string-tags
*# < "string-tag" >
0
*# number-of-real-tags
*# < real-tag >
0
*# number-of-integer-tags
*# < integer-tag >
0
*# node-number value …
$EndNodeData
$ElementData
*# number-of-string-tags
*# < "string-tag" >
0
*# number-of-real-tags
*# < real-tag >
0
*# number-of-integer-tags
*# < integer-tag >
0
*# elm-number value …
$EndElementData
$ElementNodeData
*# number-of-string-tags
*# < "string-tag" >
0
*# number-of-real-tags
*# < real-tag >
0
*# number-of-integer-tags
*# < integer-tag >
0
*# elm-number number-of-nodes-per-element value …
$EndElementNodeData
$InterpolationScheme
*# "name"
*# number-of-element-topologies
*# elm-topology
0
*# number-of-interpolation-matrices
*# num-rows num-columns value …
0
$EndInterpolationScheme
